base = raw_input("Please type the name of the Civilization 2 map file, excluding the .mp extention.\n>")
civfile = open(base + '.mp', 'rb')
civfile.seek(0)
civheader = []
for a in range(4):
    cicheader.append(ord(civfile.read(1)))

#co co rw ?? tn tn fl ?? rs rs c2 ?? r2 ??

#rw = rows
#co = columns * 2
#fl = flat flag - 1 if flat, 0 if round
#rs = resource seed
#tn = number of tiles
#c2 = columns / 2
#r2 = rows / 4 (round up)

colheader = []
columns = (civheader[1] << 8) + civheader[0]
rows = (civheader[3] << 8) + civheader[2]
tiles = columns * rows

colheader.append((columns*2) & 0xFF)
colheader.append((columns*2) >> 0xFF)
colheader.append((rows) & 0xFF)
colheader.append((rows) >> 0xFF)
colheader.append(4)
colheader.append(0)

colfile = open('col' + base + '.mp', 'wb')
colfile.seek(0)
for a in range(len(colheader)):
    colfile.write(chr(colheader[a]))
#for a in range(83):
#    colfile.write(chr(0xff))
colplace = 0x41
civplace = 0x62
rowplace = 1
river = 0
for a in range(tiles):
    colfile.seek(colplace)
    civfile.seek(civplace)
    env = ord(colfile.read(1))
    if env >= 0xc0:
        env = env - 0xc0
        river = 1
    elif env >= 0xa0:
        env = 0xa0
    elif env >= 0x40:
        env = env - 0x40
        river = 1
    elif env >= 0x20:
        env = 0x20
        
    if env == 0x0:     # tundra
        env = 0x1      # tundra
    elif env == 0x1:   # desert
        env = 0x2      # grass
    elif env == 0x2:   # plains
        env = 0x2      # grass
    elif env == 0x3:   # prarie
        env = 0x2      # grass
    elif env == 0x4:   # grassland
        env = 0x2      # grass      
    elif env == 0x5:   # savannah
        env = 0x2      # grass (again)  
    elif env == 0x6:   # marsh
        env = 0x8      # swamp
    elif env == 0x7:   # swamp
        env = 0x8      # swamp
    elif env == 0xa0:  # mountains
        env = 0x5      # mountains
    elif  env == 0x20: # hills
        env = 0x4      # hills
    elif env == 0x18:  # arctic
        env = 0x7      # arctic
    elif env == 0x19:  # ocean
        env = 0xa      # ocean
    elif env == 0x1a:  # sea lane
        env = 0xa      # ocean
    elif env >= 0x8:   # various types of forest
        env = 0x3      # forest
    else:
        print env
        env = 0xa
    if river == 1:
        env = env + 0x80
        river = 0

    civfile.write(chr(env))
    civfile.write(chr(0))
    civfile.write(chr(0))
    civfile.write(chr(0))
    civfile.write(chr(0))
    civfile.write(chr(0xf0))
    civplace = civplace + 6

    rowplace = rowplace + 1
    if rowplace > columns:
        rowplace = 1
        colplace = colplace + 3
        #civplace -= 6
    else:
        colplace = colplace + 1

civfile.close()
colfile.close()